(* Auto-generated from "gitlab.atd" *)
[@@@ocaml.warning "-27-32-33-35-39"]

type wiki_attributes = {
  wiki_attributes_title (*atd title *): string;
  wiki_attributes_content (*atd content *): string;
  wiki_attributes_format (*atd format *): string;
  wiki_attributes_slug (*atd slug *): string;
  wiki_attributes_url (*atd url *): string;
  wiki_attributes_action (*atd action *): string;
  wiki_attributes_diff_url (*atd diff_url *): string
}

type wiki = {
  wiki_web_url (*atd web_url *): string;
  wiki_git_ssh_url (*atd git_ssh_url *): string;
  wiki_git_http_url (*atd git_http_url *): string;
  wiki_path_with_namespace (*atd path_with_namespace *): string;
  wiki_default_branch (*atd default_branch *): string
}

type user_short = {
  user_short_id (*atd id *): int;
  user_short_name (*atd name *): string;
  user_short_username (*atd username *): string;
  user_short_state (*atd state *): string option;
  user_short_avatar_url (*atd avatar_url *): string option;
  user_short_web_url (*atd web_url *): string option;
  user_short_email (*atd email *): string option
}

type project_webhook = {
  project_webhook_id (*atd id *): int;
  project_webhook_name (*atd name *): string;
  project_webhook_description (*atd description *): string option;
  project_webhook_web_url (*atd web_url *): string;
  project_webhook_avatar_url (*atd avatar_url *): string option;
  project_webhook_ci_config_path (*atd ci_config_path *): string option;
  project_webhook_git_ssh_url (*atd git_ssh_url *): string;
  project_webhook_git_http_url (*atd git_http_url *): string;
  project_webhook_namespace (*atd namespace *): string;
  project_webhook_path_with_namespace (*atd path_with_namespace *): string;
  project_webhook_visibility_level (*atd visibility_level *): int;
  project_webhook_default_branch (*atd default_branch *): string
}

type wiki_page_webhook = {
  wiki_page_webhook_user (*atd user *): user_short;
  wiki_page_webhook_project (*atd project *): project_webhook;
  wiki_page_webhook_wiki (*atd wiki *): wiki;
  wiki_page_webhook_attributes (*atd attributes *): wiki_attributes
}

type wiki_page = {
  wiki_page_format (*atd format *): string;
  wiki_page_slug (*atd slug *): string;
  wiki_page_title (*atd title *): string
}

type updated_by_id = {
  update_by_id_previous (*atd previous *): int option;
  update_by_id_current (*atd current *): int
}

type updated_at = {
  updated_at_previous (*atd previous *): string;
  updated_at_current (*atd current *): string
}

type state = [ `Opened | `Closed | `Locked | `Merged ]

type source = {
  source_format (*atd format *): string;
  source_url (*atd url *): string
}

type runner_type = [ `Project | `Instance | `Group ]

type runner = {
  runner_id (*atd id *): int;
  runner_description (*atd description *): string;
  runner_runner_type (*atd runner_type *): runner_type;
  runner_active (*atd active *): bool;
  runner_is_shared (*atd is_shared *): bool;
  runner_tags (*atd tags *): string list option
}

type repository = {
  repository_name (*atd name *): string;
  repository_url (*atd url *): string;
  repository_description (*atd description *): string option;
  repository_homepage (*atd homepage *): string;
  repository_git_http_url (*atd git_http_url *): string option;
  repository_git_ssh_url (*atd git_ssh_url *): string option;
  repository_visibility_level (*atd visibility_level *): int option
}

type date_time = Gitlab_json.DateTime.t

type author = {
  author_name (*atd name *): string;
  author_email (*atd email *): string
}

type commit_short_webhook = {
  commit_short_webhook_id (*atd id *): string;
  commit_short_webhook_message (*atd message *): string;
  commit_short_webhook_title (*atd title *): string;
  commit_short_webhook_timestamp (*atd timestamp *): string;
  commit_short_webhook_url (*atd url *): string;
  commit_short_webhook_author (*atd author *): author
}

type assets = {
  assets_count (*atd count *): int;
  assets_links (*atd links *): string list;
  assets_sources (*atd sources *): source list
}

type release_webhook = {
  release_webhook_id (*atd id *): int;
  release_webhook_created_at (*atd created_at *): date_time;
  release_webhook_description (*atd description *): string;
  release_webhook_name (*atd name *): string;
  release_webhook_released_at (*atd released_at *): string;
  release_webhook_tag (*atd tag *): string;
  release_webhook_project (*atd project *): project_webhook;
  release_webhook_url (*atd url *): string;
  release_webhook_action (*atd action *): string;
  release_webhook_assets (*atd assets *): assets;
  release_webhook_commit (*atd commit *): commit_short_webhook
}

type commit_webhook = {
  commit_webhook_id (*atd id *): string;
  commit_webhook_message (*atd message *): string;
  commit_webhook_title (*atd title *): string;
  commit_webhook_timestamp (*atd timestamp *): string;
  commit_webhook_url (*atd url *): string;
  commit_webhook_author (*atd author *): author;
  commit_webhook_added (*atd added *): string list;
  commit_webhook_modified (*atd modified *): string list;
  commit_webhook_removed (*atd removed *): string list
}

type commits_webhook = commit_webhook list

type push_webhook = {
  push_webhook_event_name (*atd event_name *): string;
  push_webhook_before (*atd before *): string;
  push_webhook_after (*atd after *): string;
  push_webhook_ref (*atd ref *): string;
  push_webhook_checkout_sha (*atd checkout_sha *): string;
  push_webhook_message (*atd message *): string option;
  push_webhook_user_id (*atd user_id *): int;
  push_webhook_user_name (*atd user_name *): string;
  push_webhook_user_username (*atd user_username *): string;
  push_webhook_user_email (*atd user_email *): string option;
  push_webhook_user_avatar (*atd user_avatar *): string;
  push_webhook_project_id (*atd project_id *): int;
  push_webhook_project (*atd project *): project_webhook;
  push_webhook_commits (*atd commits *): commits_webhook;
  push_webhook_total_commits_count (*atd total_commits_count *): int;
  push_webhook_repository (*atd repository *): repository
}

type artifacts_file = {
  artifacts_file_filename (*atd filename *): string option;
  artifacts_file_size (*atd size *): int option
}

type pipeline_build = {
  pipeline_build_id (*atd id *): int;
  pipeline_build_stage (*atd stage *): string;
  pipeline_build_name (*atd name *): string;
  pipeline_build_status (*atd status *): string;
  pipeline_build_created_at (*atd created_at *): date_time;
  pipeline_build_started_at (*atd started_at *): date_time option;
  pipeline_build_finished_at (*atd finished_at *): date_time option;
  pipeline_build_duration (*atd duration *): float option;
  pipeline_build_queued_duration (*atd queued_duration *): float option;
  pipeline_build_when (*atd when *): string;
  pipeline_build_manual (*atd manual *): bool;
  pipeline_build_allow_failure (*atd allow_failure *): bool;
  pipeline_build_user (*atd user *): user_short;
  pipeline_build_runner (*atd runner *): runner option;
  pipeline_build_artifacts_file (*atd artifacts_file *): artifacts_file;
  pipeline_build_environment (*atd environment *): string option
}

type pipeline_attributes = {
  pipeline_attributes_id (*atd id *): int;
  pipeline_attributes_ref (*atd ref *): string;
  pipeline_attributes_tag (*atd tag *): bool;
  pipeline_attributes_sha (*atd sha *): string;
  pipeline_attributes_before_sha (*atd before_sha *): string;
  pipeline_attributes_source (*atd source *): string;
  pipeline_attributes_status (*atd status *): string;
  pipeline_attributes_detailed_status (*atd detailed_status *): string;
  pipeline_attributes_stages (*atd stages *): string list;
  pipeline_attributes_created_at (*atd created_at *): date_time;
  pipeline_attributes_finished_at (*atd finished_at *): date_time;
  pipeline_attributes_duration (*atd duration *): int;
  pipeline_attributes_queued_duration (*atd queued_duration *): int;
  pipeline_attributes_variables (*atd variables *): string list
}

type merge_status = [
    `Unchecked | `Checking | `CanBeMerged | `CannotBeMerged
  | `CannotBeMergedRecheck | `Preparing
]

type merge_request_short = {
  merge_request_short_id (*atd id *): int;
  merge_request_short_iid (*atd iid *): int;
  merge_request_short_title (*atd title *): string;
  merge_request_short_source_branch (*atd source_branch *): string;
  merge_request_short_source_project_id (*atd source_project_id *): int;
  merge_request_short_target_branch (*atd target_branch *): string;
  merge_request_short_target_project_id (*atd target_project_id *): int;
  merge_request_short_state (*atd state *): state;
  merge_request_short_merge_status (*atd merge_status *): merge_status;
  merge_request_short_url (*atd url *): string
}

type pipeline_webhook = {
  pipeline_webhook_attributes (*atd attributes *): pipeline_attributes;
  pipeline_webhook_merge_request (*atd merge_request *): merge_request_short;
  pipeline_webhook_user (*atd user *): user_short;
  pipeline_webhook_project (*atd project *): project_webhook;
  pipeline_webhook_commit (*atd commit *): commit_short_webhook;
  pipeline_webhook_builds (*atd builds *): pipeline_build list
}

type date = Gitlab_json.Date.t

type note_issue = {
  note_issue_author_id (*atd author_id *): int;
  note_issue_closed_at (*atd closed_at *): date_time option;
  note_issue_confidential (*atd confidential *): bool;
  note_issue_created_at (*atd created_at *): date_time;
  note_issue_description (*atd description *): string;
  note_issue_discussion_locked (*atd discussion_locked *): string option;
  note_issue_due_date (*atd due_date *): date option;
  note_issue_id (*atd id *): int;
  note_issue_iid (*atd iid *): int;
  note_issue_last_edited_at (*atd last_edited_at *): date_time option;
  note_issue_last_edited_by_id (*atd last_edited_by_id *): int option;
  note_issue_milestone_id (*atd milestone_id *): int option;
  note_issue_moved_to_id (*atd moved_to_id *): string option;
  note_issue_duplicated_to_id (*atd duplicated_to_id *): int option;
  note_issue_project_id (*atd project_id *): int;
  note_issue_relative_position (*atd relative_position *): int;
  note_issue_state_id (*atd state_id *): int;
  note_issue_time_estimate (*atd time_estimate *): int;
  note_issue_title (*atd title *): string;
  note_issue_updated_at (*atd updated_at *): date_time;
  note_issue_updated_by_id (*atd updated_by_id *): string option;
  note_issue_weight (*atd weight *): string option;
  note_issue_url (*atd url *): string;
  note_issue_total_time_spent (*atd total_time_spent *): int;
  note_issue_time_change (*atd time_change *): int;
  note_issue_human_total_time_spent (*atd human_total_time_spent *):
    int option;
  note_issue_human_time_change (*atd human_time_change *): int option;
  note_issue_human_time_estimate (*atd human_time_estimate *): int option;
  note_issue_assignee_ids (*atd assignee_ids *): int list;
  note_issue_assignee_id (*atd assignee_id *): int;
  note_issue_labels (*atd labels *): string list;
  note_issue_state (*atd state *): state;
  note_issue_severity (*atd severity *): string
}

type note_attributes = {
  note_attrbutes_attachment (*atd attachment *): string option;
  note_attrbutes_author_id (*atd author_id *): int;
  note_attrbutes_change_position (*atd change_position *): string option;
  note_attrbutes_commit_id (*atd commit_id *): string option;
  note_attrbutes_created_at (*atd created_at *): date_time;
  note_attrbutes_discussion_id (*atd discussion_id *): string;
  note_attrbutes_id (*atd id *): int;
  note_attrbutes_line_code (*atd line_code *): int option;
  note_attrbutes_note (*atd note *): string;
  note_attrbutes_noteable_id (*atd noteable_id *): int;
  note_attrbutes_noteable_type (*atd noteable_type *): string;
  note_attrbutes_original_position (*atd original_position *): string option;
  note_attrbutes_position (*atd position *): string option;
  note_attrbutes_project_id (*atd project_id *): int;
  note_attrbutes_resolved_at (*atd resolved_at *): date_time option;
  note_attrbutes_resolved_by_id (*atd resolved_by_id *): string option;
  note_attrbutes_resolved_by_push (*atd resolved_by_push *): string option;
  note_attrbutes_st_diff (*atd st_diff *): string option;
  note_attrbutes_system (*atd system *): bool;
  note_attrbutes_note_attribute_type (*atd note_attribute_type *):
    string option;
  note_attrbutes_updated_at (*atd updated_at *): date_time;
  note_attrbutes_updated_by_id (*atd updated_by_id *): string option;
  note_attrbutes_description (*atd description *): string;
  note_attrbutes_url (*atd url *): string
}

type note_webhook = {
  note_webhook_event_type (*atd event_type *): string;
  note_webhook_user (*atd user *): user_short;
  note_webhook_project (*atd project *): project_webhook;
  note_webhook_attributes (*atd attributes *): note_attributes;
  note_webhook_repository (*atd repository *): repository;
  note_webhook_project_id (*atd project_id *): int;
  note_webhook_issue (*atd issue *): note_issue
}

type assignees = {
  assignees_previous (*atd previous *): user_short list;
  assignees_current (*atd current *): user_short list
}

type merge_request_changes = {
  merge_request_changes_updated_by_id (*atd updated_by_id *):
    updated_by_id option;
  merge_request_changes_updated_at (*atd updated_at *): updated_at option;
  merge_request_changes_assignees (*atd assignees *): assignees option
}

type merge_params = {
  merge_params_force_remove_source_branch (*atd force_remove_source_branch *):
    string
}

type merge_request_attributes = {
  merge_request_attributes_action (*atd action *): string option;
  merge_request_attributes_assignee_id (*atd assignee_id *): int option;
  merge_request_attributes_assignee_ids (*atd assignee_ids *): int list;
  merge_request_attributes_author_id (*atd author_id *): int;
  merge_request_attributes_created_at (*atd created_at *): date_time;
  merge_request_attributes_description (*atd description *): string;
  merge_request_attributes_head_pipeline_id (*atd head_pipeline_id *):
    int option;
  merge_request_attributes_id (*atd id *): int;
  merge_request_attributes_iid (*atd iid *): int;
  merge_request_attributes_last_edited_at (*atd last_edited_at *):
    date_time option;
  merge_request_attributes_last_edited_by_id (*atd last_edited_by_id *):
    int option;
  merge_request_attributes_last_commit (*atd last_commit *):
    commit_short_webhook;
  merge_request_attributes_oldrev (*atd oldrev *): string option;
  merge_request_attributes_merge_commit_sha (*atd merge_commit_sha *):
    string option;
  merge_request_attributes_merge_error (*atd merge_error *): string option;
  merge_request_attributes_merge_params (*atd merge_params *): merge_params;
  merge_request_attributes_merge_status (*atd merge_status *): merge_status;
  merge_request_attributes_merge_user_id (*atd merge_user_id *): int option;
  merge_request_attributes_merge_when_pipeline_succeeds (*atd merge_when_pipeline_succeeds *):
    bool;
  merge_request_attributes_milestone_id (*atd milestone_id *): int option;
  merge_request_attributes_source (*atd source *): project_webhook;
  merge_request_attributes_source_branch (*atd source_branch *): string;
  merge_request_attributes_source_project_id (*atd source_project_id *): int;
  merge_request_attributes_state_id (*atd state_id *): int;
  merge_request_attributes_state (*atd state *): string;
  merge_request_attributes_target (*atd target *): project_webhook;
  merge_request_attributes_target_branch (*atd target_branch *): string;
  merge_request_attributes_target_project_id (*atd target_project_id *): int;
  merge_request_attributes_title (*atd title *): string;
  merge_request_attributes_updated_at (*atd updated_at *): date_time;
  merge_request_attributes_updated_by_id (*atd updated_by_id *): int option;
  merge_request_attributes_url (*atd url *): string;
  merge_request_attributes_work_in_progress (*atd work_in_progress *): bool;
  merge_request_attributes_total_time_spent (*atd total_time_spent *): int;
  merge_request_attributes_time_change (*atd time_change *): int;
  merge_request_attributes_time_estimate (*atd time_estimate *): int;
  merge_request_attributes_human_total_time_spent (*atd human_total_time_spent *):
    int option;
  merge_request_attributes_human_time_change (*atd human_time_change *):
    int option;
  merge_request_attributes_human_time_estimate (*atd human_time_estimate *):
    int option
}

type label = {
  label_id (*atd id *): int;
  label_title (*atd title *): string;
  label_color (*atd color *): string;
  label_project_id (*atd project_id *): int;
  label_created_at (*atd created_at *): date_time;
  label_updated_at (*atd updated_at *): date_time;
  label_template (*atd template *): bool;
  label_description (*atd description *): string option;
  label_label_type (*atd label_type *): string;
  label_group_id (*atd group_id *): int option
}

type merge_request_webhook = {
  merge_request_webhook_event_type (*atd event_type *): string;
  merge_request_webhook_user (*atd user *): user_short;
  merge_request_webhook_project (*atd project *): project_webhook;
  merge_request_webhook_attributes (*atd attributes *):
    merge_request_attributes;
  merge_request_webhook_repository (*atd repository *): repository;
  merge_request_webhook_labels (*atd labels *): label list;
  merge_request_webhook_changes (*atd changes *):
    merge_request_changes option;
  merge_request_webhook_assignees (*atd assignees *): user_short list option
}

type job_webhook_commit = {
  job_webhook_commit_id (*atd id *): int;
  job_webhook_commit_sha (*atd sha *): string;
  job_webhook_commit_message (*atd message *): string;
  job_webhook_commit_author_name (*atd author_name *): string;
  job_webhook_commit_author_email (*atd author_email *): string;
  job_webhook_commit_author_url (*atd author_url *): string;
  job_webhook_commit_status (*atd status *): string;
  job_webhook_commit_duration (*atd duration *): float option;
  job_webhook_commit_started_at (*atd started_at *): date_time;
  job_webhook_commit_finished_at (*atd finished_at *): date_time option
}

type job_webhook = {
  job_webhook_ref (*atd ref *): string;
  job_webhook_tag (*atd tag *): bool;
  job_webhook_before_sha (*atd before_sha *): string;
  job_webhook_sha (*atd sha *): string;
  job_webhook_build_id (*atd build_id *): int;
  job_webhook_build_name (*atd build_name *): string;
  job_webhook_build_stage (*atd build_stage *): string;
  job_webhook_build_status (*atd build_status *): string;
  job_webhook_build_created_at (*atd build_created_at *): date_time;
  job_webhook_build_started_at (*atd build_started_at *): date_time;
  job_webhook_build_finished_at (*atd build_finished_at *): date_time;
  job_webhook_build_duration (*atd build_duration *): float;
  job_webhook_build_queued_duration (*atd build_queued_duration *): float;
  job_webhook_build_allow_failure (*atd build_allow_failure *): bool;
  job_webhook_build_failure_reason (*atd build_failure_reason *): string;
  job_webhook_pipeline_id (*atd pipeline_id *): int;
  job_webhook_runner (*atd runner *): runner;
  job_webhook_project_id (*atd project_id *): int;
  job_webhook_project_name (*atd project_name *): string;
  job_webhook_user (*atd user *): user_short;
  job_webhook_commit (*atd commit *): job_webhook_commit;
  job_webhook_repository (*atd repository *): repository;
  job_webhook_environment (*atd environment *): string option
}

type issue_attributes = {
  issue_attributes_assignee_id (*atd assignee_id *): int option;
  issue_attributes_assignee_ids (*atd assignee_ids *): int list;
  issue_attributes_author_id (*atd author_id *): int;
  issue_attributes_closed_at (*atd closed_at *): date_time option;
  issue_attributes_confidential (*atd confidential *): bool;
  issue_attributes_created_at (*atd created_at *): date_time;
  issue_attributes_description (*atd description *): string;
  issue_attributes_discussion_locked (*atd discussion_locked *):
    string option;
  issue_attributes_due_date (*atd due_date *): string option;
  issue_attributes_duplicated_to_id (*atd duplicated_to_id *): string option;
  issue_attributes_human_time_change (*atd human_time_change *):
    string option;
  issue_attributes_human_time_estimate (*atd human_time_estimate *):
    string option;
  issue_attributes_human_total_time_spent (*atd human_total_time_spent *):
    string option;
  issue_attributes_id (*atd id *): int;
  issue_attributes_iid (*atd iid *): int;
  issue_attributes_labels (*atd labels *): string list;
  issue_attributes_last_edited_at (*atd last_edited_at *): date_time option;
  issue_attributes_last_edited_by_id (*atd last_edited_by_id *): int option;
  issue_attributes_milestone_id (*atd milestone_id *): int option;
  issue_attributes_moved_to_id (*atd moved_to_id *): int option;
  issue_attributes_project_id (*atd project_id *): int;
  issue_attributes_relative_position (*atd relative_position *): int;
  issue_attributes_severity (*atd severity *): string;
  issue_attributes_state (*atd state *): string;
  issue_attributes_state_id (*atd state_id *): int;
  issue_attributes_time_change (*atd time_change *): int;
  issue_attributes_time_estimate (*atd time_estimate *): int;
  issue_attributes_title (*atd title *): string;
  issue_attributes_total_time_spent (*atd total_time_spent *): int;
  issue_attributes_updated_at (*atd updated_at *): date_time;
  issue_attributes_updated_by_id (*atd updated_by_id *): int option;
  issue_attributes_url (*atd url *): string;
  issue_attributes_weight (*atd weight *): int option
}

type issue_webhook = {
  issue_webhook_event_type (*atd event_type *): string;
  issue_webhook_user (*atd user *): user_short;
  issue_webhook_project (*atd project *): project_webhook;
  issue_webhook_attributes (*atd attributes *): issue_attributes;
  issue_webhook_labels (*atd labels *): label list;
  issue_webhook_repository (*atd repository *): repository;
  issue_webhook_assignees (*atd assignees *): user_short list
}

type feature_flag_attributes = {
  id: int;
  name: string;
  description: string;
  active: bool
}

type feature_flag_webhook = {
  project: project_webhook;
  user: user_short;
  user_url: string;
  object_attributes: feature_flag_attributes
}

type deployment_webhook = {
  status: string;
  status_changed_at: date_time;
  deployment_id: int;
  deployable_id: int;
  deployable_url: string;
  environment: string;
  project: project_webhook;
  short_sha: string;
  user: user_short;
  user_url: string;
  commit_url: string;
  commit_title: string
}

type webhook = [
    `Push of push_webhook
  | `MergeRequest of merge_request_webhook
  | `Issue of issue_webhook
  | `Note of note_webhook
  | `WikiPage of wiki_page_webhook
  | `Release of release_webhook
  | `Job of job_webhook
  | `Pipeline of pipeline_webhook
  | `Deployment of deployment_webhook
  | `FeatureFlag of feature_flag_webhook
]

type webhooks = webhook list

type visibility = [ `Private | `Public | `Internal ]

type users = user_short list

type user = {
  user_id (*atd id *): int;
  user_name (*atd name *): string;
  user_username (*atd username *): string;
  user_state (*atd state *): string option;
  user_avatar_url (*atd avatar_url *): string option;
  user_web_url (*atd web_url *): string option;
  user_email (*atd email *): string option;
  user_created_at (*atd created_at *): date_time;
  user_bio (*atd bio *): string option;
  user_bio_html (*atd bio_html *): string option;
  user_location (*atd location *): string option;
  user_public_email (*atd public_email *): string option;
  user_skype (*atd skype *): string option;
  user_linkedin (*atd linkedin *): string option;
  user_twitter (*atd twitter *): string option;
  user_discord (*atd discord *): string option;
  user_website_url (*atd website_url *): string option;
  user_organization (*atd organization *): string option;
  user_job_title (*atd job_title *): string option;
  user_pronouns (*atd pronouns *): string option;
  user_bot (*atd bot *): bool;
  user_work_information (*atd work_information *): string option;
  user_followers (*atd followers *): int option;
  user_following (*atd following *): int option
}

type time_stats = {
  time_stats_time_estimate (*atd time_estimate *): int;
  time_stats_total_time_spent (*atd total_time_spent *): int;
  time_stats_human_time_estimate (*atd human_time_estimate *): string option;
  time_stats_human_total_time_spent (*atd human_total_time_spent *):
    string option
}

type task_completion_status = {
  time_completion_status_count (*atd count *): int;
  time_completion_status_completed_count (*atd completed_count *): int
}

type status_check_status = [ `Approved | `Pending ]

type status_check = {
  status_check_id (*atd id *): int;
  status_check_name (*atd name *): string;
  status_check_external_url (*atd external_url *): string;
  status_check_status (*atd status *): status_check_status
}

type status_checks = status_check list

type statistics = {
  statistics_commit_count (*atd commit_count *): int;
  statistics_storage_size (*atd storage_size *): int;
  statistics_repository_size (*atd repository_size *): int;
  statistics_wiki_size (*atd wiki_size *): int;
  statistics_lfs_objects_size (*atd lfs_objects_size *): int;
  statistics_job_artifacts_size (*atd job_artifacts_size *): int;
  statistics_packages_size (*atd packages_size *): int;
  statistics_snippets_size (*atd snippets_size *): int
}

type sort = [ `Asc | `Desc ]

type pipeline_status = [
    `Created | `WaitingForResource | `Preparing | `Pending | `Running
  | `Success | `Failed | `Canceled | `Skipped | `Manual | `Scheduled
]

type pipeline_source = [
    `Push | `Web | `Trigger | `Schedule | `Api | `External | `Pipeline
  | `Chat | `Webide | `Merge_Request_Event | `External_Pull_Request_Event
  | `Parent_Pipeline | `Ondemand_Dast_Scan | `Ondemand_Dast_Validation
]

type single_pipeline = {
  id: int;
  iid: int;
  project_id: int;
  status: pipeline_status;
  source: pipeline_source;
  ref: string;
  sha: string;
  web_url: string;
  tag: bool;
  started_at: date_time option;
  created_at: date_time;
  updated_at: date_time option;
  finished_at: date_time option;
  user: user_short;
  duration: float option;
  queued_duration: float option
}

type scope = [
    `Api | `ReadApi | `ReadUser | `ReadRegistry | `WriteRegistry
  | `ReadRepository | `WriteRepository
]

type scim_identity = {
  scim_identity_extern_uid (*atd extern_uid *): string;
  scim_identity_group_id (*atd group_id *): int;
  scim_identity_active (*atd active *): bool
}

type runners = runner list

type references = {
  references_short (*atd short *): string;
  references_relative (*atd relative *): string;
  references_full (*atd full *): string
}

type push_data = {
  push_data_commit_count (*atd commit_count *): int;
  push_data_action (*atd action *): string;
  push_data_ref_type (*atd ref_type *): string;
  push_data_commit_from (*atd commit_from *): string option;
  push_data_commit_to (*atd commit_to *): string option;
  push_data_ref (*atd ref *): string option;
  push_data_commit_title (*atd commit_title *): string option;
  push_data_ref_count (*atd ref_count *): int option
}

type namespace = {
  namespace_id (*atd id *): int;
  namespace_name (*atd name *): string;
  namespace_path (*atd path *): string;
  namespace_kind (*atd kind *): string;
  namespace_full_path (*atd full_path *): string;
  namespace_parent_id (*atd parent_id *): int option;
  namespace_avatar_url (*atd avatar_url *): string option;
  namespace_web_url (*atd web_url *): string
}

type project_short = {
  project_short_id (*atd id *): int;
  project_short_name (*atd name *): string;
  project_short_description (*atd description *): string option;
  project_short_name_with_namespace (*atd name_with_namespace *): string;
  project_short_path (*atd path *): string;
  project_short_path_with_namespace (*atd path_with_namespace *): string;
  project_short_created_at (*atd created_at *): date_time;
  project_short_default_branch (*atd default_branch *): string;
  project_short_tag_list (*atd tag_list *): string list option;
  project_short_topics (*atd topics *): string list option;
  project_short_ssh_url_to_repo (*atd ssh_url_to_repo *): string;
  project_short_http_url_to_repo (*atd http_url_to_repo *): string;
  project_short_web_url (*atd web_url *): string;
  project_short_readme_url (*atd readme_url *): string option;
  project_short_avatar_url (*atd avatar_url *): string option;
  project_short_forks_count (*atd forks_count *): int;
  project_short_star_count (*atd star_count *): int;
  project_short_last_activity_at (*atd last_activity_at *): date_time;
  project_short_namespace (*atd namespace *): namespace
}

type projects_short = project_short list

type project_access = {
  project_access_access_level (*atd access_level *): int;
  project_access_notification_level (*atd notification_level *): int
}

type permissions = {
  permissions_group_access (*atd group_access *): string option;
  permissions_project_access (*atd project_access *): project_access
}

type merge_method = [ `Merge | `RebaseMerge | `FastForward ]

type links = {
  links_self (*atd self *): string;
  links_notes (*atd notes *): string option;
  links_award_emoji (*atd award_emoji *): string option;
  links_project (*atd project *): string option;
  links_issues (*atd issues *): string option;
  links_merge_requests (*atd merge_requests *): string option;
  links_repo_branches (*atd repo_branches *): string option;
  links_labels (*atd labels *): string option;
  links_events (*atd events *): string option;
  links_members (*atd members *): string option
}

type container_expiration_policy = {
  container_expiration_policy_cadence (*atd cadence *): string;
  container_expiration_policy_enabled (*atd enabled *): bool;
  container_expiration_policy_keep_n (*atd keep_n *): int;
  container_expiration_policy_name_regex (*atd name_regex *): string;
  container_expiration_policy_name_regex_keep (*atd name_regex_keep *):
    string option;
  container_expiration_policy_next_run_at (*atd next_run_at *): date_time;
  container_expiration_policy_older_than (*atd older_than *): string
}

type project_full = {
  project_full_id (*atd id *): int;
  project_full_name (*atd name *): string;
  project_full_description (*atd description *): string option;
  project_full_name_with_namespace (*atd name_with_namespace *): string;
  project_full_created_at (*atd created_at *): date_time;
  project_full_default_branch (*atd default_branch *): string;
  project_full_tag_list (*atd tag_list *): string list option;
  project_full_topics (*atd topics *): string list option;
  project_full_ssh_url_to_repo (*atd ssh_url_to_repo *): string;
  project_full_http_url_to_repo (*atd http_url_to_repo *): string;
  project_full_web_url (*atd web_url *): string;
  project_full_readme_url (*atd readme_url *): string option;
  project_full_avatar_url (*atd avatar_url *): string option;
  project_full_forks_count (*atd forks_count *): int;
  project_full_star_count (*atd star_count *): int;
  project_full_last_activity_at (*atd last_activity_at *): date_time;
  project_full_namespace (*atd namespace *): namespace;
  project_full_runners_token (*atd runners_token *): string option;
  project_full_statistics (*atd statistics *): statistics option;
  project_full_allow_merge_on_skipped_pipeline (*atd allow_merge_on_skipped_pipeline *):
    bool option;
  project_full_analytics_access_level (*atd analytics_access_level *): string;
  project_full_approvals_before_merge (*atd approvals_before_merge *): int;
  project_full_archived (*atd archived *): bool;
  project_full_auto_cancel_pending_pipelines (*atd auto_cancel_pending_pipelines *):
    string;
  project_full_auto_devops_deploy_strategy (*atd auto_devops_deploy_strategy *):
    string;
  project_full_auto_devops_enabled (*atd auto_devops_enabled *): bool;
  project_full_autoclose_referenced_issues (*atd autoclose_referenced_issues *):
    bool;
  project_full_build_coverage_regex (*atd build_coverage_regex *):
    string option;
  project_full_build_timeout (*atd build_timeout *): int;
  project_full_builds_access_level (*atd builds_access_level *): string;
  project_full_can_create_merge_request_in (*atd can_create_merge_request_in *):
    bool;
  project_full_ci_config_path (*atd ci_config_path *): string option;
  project_full_ci_default_git_depth (*atd ci_default_git_depth *): int option;
  project_full_ci_forward_deployment_enabled (*atd ci_forward_deployment_enabled *):
    bool option;
  project_full_ci_job_token_scope_enabled (*atd ci_job_token_scope_enabled *):
    bool;
  project_full_compliance_frameworks (*atd compliance_frameworks *):
    string list;
  project_full_container_expiration_policy (*atd container_expiration_policy *):
    container_expiration_policy option;
  project_full_container_registry_access_level (*atd container_registry_access_level *):
    string;
  project_full_container_registry_enabled (*atd container_registry_enabled *):
    bool;
  project_full_container_registry_image_prefix (*atd container_registry_image_prefix *):
    string;
  project_full_creator_id (*atd creator_id *): int;
  project_full_emails_disabled (*atd emails_disabled *): string option;
  project_full_empty_repo (*atd empty_repo *): bool;
  project_full_external_authorization_classification_label (*atd external_authorization_classification_label *):
    string;
  project_full_forked_from_project (*atd forked_from_project *):
    project_short option;
  project_full_forking_access_level (*atd forking_access_level *): string;
  project_full_import_status (*atd import_status *): string;
  project_full_issues_access_level (*atd issues_access_level *): string;
  project_full_issues_enabled (*atd issues_enabled *): bool;
  project_full_issues_template (*atd issues_template *): string option;
  project_full_jobs_enabled (*atd jobs_enabled *): bool;
  project_full_keep_latest_artifact (*atd keep_latest_artifact *): bool;
  project_full_lfs_enabled (*atd lfs_enabled *): bool;
  project_full_links (*atd links *): links;
  project_full_marked_for_deletion_at (*atd marked_for_deletion_at *):
    date option;
  project_full_marked_for_deletion_on (*atd marked_for_deletion_on *):
    date option;
  project_full_merge_method (*atd merge_method *): merge_method;
  project_full_merge_pipelines_enabled (*atd merge_pipelines_enabled *): bool;
  project_full_merge_requests_access_level (*atd merge_requests_access_level *):
    string;
  project_full_merge_requests_enabled (*atd merge_requests_enabled *): bool;
  project_full_merge_requests_template (*atd merge_requests_template *):
    string option;
  project_full_merge_trains_enabled (*atd merge_trains_enabled *): bool;
  project_full_mirror (*atd mirror *): bool;
  project_full_only_allow_merge_if_all_discussions_are_resolved (*atd only_allow_merge_if_all_discussions_are_resolved *):
    bool option;
  project_full_only_allow_merge_if_pipeline_succeeds (*atd only_allow_merge_if_pipeline_succeeds *):
    bool;
  project_full_open_issues_count (*atd open_issues_count *): int;
  project_full_operations_access_level (*atd operations_access_level *):
    string;
  project_full_owner (*atd owner *): user_short;
  project_full_packages_enabled (*atd packages_enabled *): bool option;
  project_full_pages_access_level (*atd pages_access_level *): string;
  project_full_path (*atd path *): string;
  project_full_path_with_namespace (*atd path_with_namespace *): string;
  project_full_permissions (*atd permissions *): permissions;
  project_full_public_jobs (*atd public_jobs *): bool;
  project_full_printing_merge_request_link_enabled (*atd printing_merge_request_link_enabled *):
    bool;
  project_full_remove_source_branch_after_merge (*atd remove_source_branch_after_merge *):
    bool option;
  project_full_repository_access_level (*atd repository_access_level *):
    string;
  project_full_request_access_enabled (*atd request_access_enabled *): bool;
  project_full_requirements_enabled (*atd requirements_enabled *): bool;
  project_full_resolve_outdated_diff_discussions (*atd resolve_outdated_diff_discussions *):
    bool option;
  project_full_restrict_user_defined_variables (*atd restrict_user_defined_variables *):
    bool option;
  project_full_security_and_compliance_enabled (*atd security_and_compliance_enabled *):
    bool;
  project_full_service_desk_address (*atd service_desk_address *):
    string option;
  project_full_service_desk_enabled (*atd service_desk_enabled *):
    bool option;
  project_full_shared_runners_enabled (*atd shared_runners_enabled *): bool;
  project_full_shared_with_groups (*atd shared_with_groups *): string list;
  project_full_snippets_enabled (*atd snippets_enabled *): bool;
  project_full_snippets_access_level (*atd snippets_access_level *): string;
  project_full_squash_option (*atd squash_option *): string;
  project_full_suggestion_commit_message (*atd suggestion_commit_message *):
    string option;
  project_full_visibility (*atd visibility *): visibility;
  project_full_wiki_access_level (*atd wiki_access_level *): string;
  project_full_wiki_enabled (*atd wiki_enabled *): bool
}

type projects_full = project_full list

type project_shorts = project_short list

type project_hook = {
  id: int;
  url: string;
  created_at: date_time;
  push_events: bool;
  tag_push_events: bool;
  merge_requests_events: bool;
  repository_update_events: bool;
  enable_ssl_verification: bool;
  project_id: int;
  issues_events: bool;
  confidential_issues_events: bool;
  note_events: bool;
  pipeline_events: bool;
  wiki_page_events: bool;
  deployment_events: bool;
  job_events: bool;
  releases_events: bool;
  confidential_note_events: bool option;
  push_events_branch_filter: string option
}

type project_hooks = project_hook list

type project_access_token = {
  project_access_token_id (*atd id *): int;
  project_access_token_name (*atd name *): string;
  project_access_token_revoked (*atd revoked *): bool;
  project_access_token_created_at (*atd created_at *): date_time;
  project_access_token_scopes (*atd scopes *): scope list;
  project_access_token_user_id (*atd user_id *): int;
  project_access_token_active (*atd active *): bool;
  project_access_token_expires_at (*atd expires_at *): string option
}

type project_access_tokens = project_access_token list

type pipeline = {
  id: int;
  iid: int;
  project_id: int;
  status: pipeline_status;
  source: pipeline_source;
  ref: string;
  sha: string;
  web_url: string;
  created_at: date_time;
  updated_at: date_time
}

type pipelines = pipeline list

type pipeline_scope = [ `Running | `Pending | `Finished | `Branches | `Tags ]

type pipeline_job_status = [
    `Created | `Pending | `Running | `Failed | `Success | `Canceled
  | `Skipped | `Manual
]

type pipeline_job_failure_reason = [
    `Script_failure | `Runner_system_failure | `Job_execution_timeout
  | `Stuck_or_timeout_failure | `Unknown_failure | `Scheduler_failure
  | `Data_integrity_failure | `Api_failure | `Missing_dependency_failure
  | `Runner_unsupported | `Stale_schedule | `Archived_failure
  | `Unmet_prerequisites | `Forward_deployment_failure | `User_blocked
  | `Project_deleted | `Ci_quota_exceeded | `Pipeline_loop_detected
  | `No_matching_runner | `Trace_size_exceeded | `Builds_disabled
  | `Environment_creation_failure | `Deployment_rejected
  | `Failed_outdated_deployment_job | `Protected_environment_failure
  | `Insufficient_bridge_permissions | `Downstream_bridge_project_not_found
  | `Invalid_bridge_trigger | `Upstream_bridge_project_not_found
  | `Insufficient_upstream_permissions | `Bridge_pipeline_is_child_pipeline
  | `Downstream_pipeline_creation_failed | `Secrets_provider_not_found
  | `Reached_max_descendant_pipelines_depth | `Ip_restriction_failure
  | `Reached_max_pipeline_hierarchy_size
]

type commit = {
  commit_id (*atd id *): string;
  commit_short_id (*atd short_id *): string;
  commit_title (*atd title *): string;
  commit_author_name (*atd author_name *): string;
  commit_author_email (*atd author_email *): string;
  commit_authored_date (*atd authored_date *): string;
  commit_committed_date (*atd committed_date *): date_time;
  commit_committer_email (*atd committer_email *): string;
  commit_committer_name (*atd committer_name *): string;
  commit_created_at (*atd created_at *): date_time;
  commit_message (*atd message *): string;
  commit_parent_ids (*atd parent_ids *): string list option;
  commit_web_url (*atd web_url *): string
}

type pipeline_job = {
  id: int;
  name: string;
  status: pipeline_job_status;
  failure_reason: pipeline_job_failure_reason option;
  ref: string;
  web_url: string;
  created_at: date_time;
  started_at: date_time option;
  finished_at: date_time option;
  user: user_short;
  duration: float option;
  queued_duration: float option;
  commit: commit;
  pipeline: pipeline;
  artifacts: artifacts_file list
}

type pipeline_jobs = pipeline_job list

type pipeline_job_scope = [
    `Created | `Pending | `Running | `Failed | `Success | `Canceled
  | `Skipped | `Manual
]

type personal_access_token = {
  personal_access_token_id (*atd id *): int;
  personal_access_token_name (*atd name *): string;
  personal_access_token_revoked (*atd revoked *): bool;
  personal_access_token_created_at (*atd created_at *): date_time;
  personal_access_token_scopes (*atd scopes *): scope list;
  personal_access_token_user_id (*atd user_id *): int;
  personal_access_token_active (*atd active *): bool;
  personal_access_token_expires_at (*atd expires_at *): string option
}

type personal_access_tokens = personal_access_token list

type owner = {
  owner_id (*atd id *): int;
  owner_name (*atd name *): string;
  owner_created_at (*atd created_at *): date_time
}

type noteable_type = [ `MergeRequest | `Issue ]

type command_changes = { promote_to_epic: bool option }

type note = {
  note_id (*atd id *): int;
  note_note_type (*atd note_type *): string option;
  note_body (*atd body *): string;
  note_attachment (*atd attachment *): string option;
  note_author (*atd author *): user_short;
  note_created_at (*atd created_at *): date_time;
  note_updated_at (*atd updated_at *): date_time;
  note_system (*atd system *): bool;
  note_noteable_id (*atd noteable_id *): int;
  note_noteable_type (*atd noteable_type *): noteable_type;
  note_resolvable (*atd resolvable *): bool;
  note_confidential (*atd confidential *): bool;
  note_noteable_iid (*atd noteable_iid *): int;
  note_commands_changes (*atd commands_changes *): command_changes option
}

type notes = note list

type new_token = { name: string; expires_at: string; scopes: scope list }

type commit_status_status = [
    `Pending | `Running | `Success | `Failed | `Cancelled
]

type new_status = {
  state: commit_status_status;
  ref_name: string option;
  name: string option;
  target_url: string option;
  description: string option;
  coverage: int option;
  pipeline_id: int option
}

type new_milestone = {
  title: string;
  description: string option;
  due_date: string option;
  start_date: string option
}

type line_type = [ `New | `Old ]

type new_comment = {
  note: string;
  path: string option;
  line: int option;
  line_type: line_type option
}

type milestone_state = [ `Active | `Closed ]

type milestone = {
  milestone_id (*atd id *): int;
  milestone_iid (*atd iid *): int;
  milestone_project_id (*atd project_id *): int option;
  milestone_group_id (*atd group_id *): int option;
  milestone_title (*atd title *): string;
  milestone_description (*atd description *): string;
  milestone_state (*atd state *): milestone_state;
  milestone_created_at (*atd created_at *): date_time;
  milestone_updated_at (*atd updated_at *): date_time;
  milestone_due_date (*atd due_date *): date option;
  milestone_start_date (*atd start_date *): date option;
  milestone_expired (*atd expired *): bool option;
  milestone_web_url (*atd web_url *): string
}

type milestones = milestone list

type error = {
  error_resource (*atd resource *): string;
  error_field (*atd field *): string option;
  error_code (*atd code *): string;
  error_message (*atd message *): string option
}

type message = {
  message_message (*atd message *): string;
  message_errors (*atd errors *): error list
}

type merge_request = {
  merge_request_id (*atd id *): int;
  merge_request_iid (*atd iid *): int;
  merge_request_project_id (*atd project_id *): int;
  merge_request_title (*atd title *): string;
  merge_request_description (*atd description *): string;
  merge_request_state (*atd state *): state;
  merge_request_merged_by (*atd merged_by *): user_short option;
  merge_request_merged_at (*atd merged_at *): date_time option;
  merge_request_closed_by (*atd closed_by *): user_short option;
  merge_request_closed_at (*atd closed_at *): date_time option;
  merge_request_created_at (*atd created_at *): date_time;
  merge_request_updated_at (*atd updated_at *): date_time;
  merge_request_target_branch (*atd target_branch *): string;
  merge_request_source_branch (*atd source_branch *): string;
  merge_request_upvotes (*atd upvotes *): int;
  merge_request_downvotes (*atd downvotes *): int;
  merge_request_author (*atd author *): user_short;
  merge_request_assignee (*atd assignee *): user_short option;
  merge_request_approvals_before_merge (*atd approvals_before_merge *):
    int option;
  merge_request_allow_collaboration (*atd allow_collaboration *): bool option;
  merge_request_allow_maintainer_to_push (*atd allow_maintainer_to_push *):
    bool option;
  merge_request_blocking_discussions_resolved (*atd blocking_discussions_resolved *):
    bool;
  merge_request_has_conflicts (*atd has_conflicts *): bool;
  merge_request_assignees (*atd assignees *): user_short list;
  merge_request_reviewers (*atd reviewers *): user_short list;
  merge_request_source_project_id (*atd source_project_id *): int option;
  merge_request_target_project_id (*atd target_project_id *): int;
  merge_request_labels (*atd labels *): string list;
  merge_request_draft (*atd draft *): bool;
  merge_request_work_in_progress (*atd work_in_progress *): bool;
  merge_request_milestone (*atd milestone *): milestone option;
  merge_request_merge_when_pipeline_succeeds (*atd merge_when_pipeline_succeeds *):
    bool;
  merge_request_merge_status (*atd merge_status *): merge_status;
  merge_request_sha (*atd sha *): string option;
  merge_request_merge_commit_sha (*atd merge_commit_sha *): string option;
  merge_request_squash_commit_sha (*atd squash_commit_sha *): string option;
  merge_request_user_notes_count (*atd user_notes_count *): int;
  merge_request_discussion_locked (*atd discussion_locked *): bool option;
  merge_request_should_remove_source_branch (*atd should_remove_source_branch *):
    bool option;
  merge_request_force_remove_source_branch (*atd force_remove_source_branch *):
    bool option;
  merge_request_web_url (*atd web_url *): string;
  merge_request_reference (*atd reference *): string;
  merge_request_references (*atd references *): references;
  merge_request_time_stats (*atd time_stats *): time_stats;
  merge_request_squash (*atd squash *): bool;
  merge_request_task_completion_status (*atd task_completion_status *):
    task_completion_status option
}

type merge_requests = merge_request list

type merge_request_scope = [ `CreatedByMe | `AssignedToMe | `All ]

type labels = {
  labels_previous (*atd previous *): label list;
  labels_current (*atd current *): label list
}

type issue_type = [ `Issue | `Incident | `TestCase ]

type issue = {
  issue_id (*atd id *): int;
  issue_iid (*atd iid *): int;
  issue_project_id (*atd project_id *): int;
  issue_title (*atd title *): string;
  issue_description (*atd description *): string;
  issue_state (*atd state *): state;
  issue_created_at (*atd created_at *): date_time;
  issue_updated_at (*atd updated_at *): date_time;
  issue_closed_at (*atd closed_at *): date_time option;
  issue_closed_by (*atd closed_by *): user_short option;
  issue_labels (*atd labels *): string list;
  issue_milestone (*atd milestone *): string option;
  issue_assignees (*atd assignees *): user_short list;
  issue_author (*atd author *): user_short;
  issue_type_ (*atd type_ *): string;
  issue_assignee (*atd assignee *): user_short option;
  issue_user_notes_count (*atd user_notes_count *): int;
  issue_merge_requests_count (*atd merge_requests_count *): int;
  issue_upvotes (*atd upvotes *): int;
  issue_downvotes (*atd downvotes *): int;
  issue_due_date (*atd due_date *): date option;
  issue_confidential (*atd confidential *): bool;
  issue_discussion_locked (*atd discussion_locked *): string option;
  issue_issue_type (*atd issue_type *): issue_type;
  issue_web_url (*atd web_url *): string;
  issue_time_stats (*atd time_stats *): time_stats;
  issue_task_completion_status (*atd task_completion_status *):
    task_completion_status;
  issue_weight (*atd weight *): int option;
  issue_blocking_issues_count (*atd blocking_issues_count *): int;
  issue_has_tasks (*atd has_tasks *): bool;
  issue_links (*atd links *): links;
  issue_references (*atd references *): references;
  issue_severity (*atd severity *): string;
  issue_moved_to_id (*atd moved_to_id *): string option;
  issue_service_desk_reply_to (*atd service_desk_reply_to *): string option;
  issue_health_status (*atd health_status *): string option
}

type issues = issue list

type identity = {
  identity_provider (*atd provider *): string;
  identity_extern_uid (*atd extern_uid *): int;
  identity_saml_provider_id (*atd saml_provider_id *): int option
}

type branch = {
  branch_id (*atd id *): int;
  branch_project_id (*atd project_id *): int;
  branch_name (*atd name *): string;
  branch_created_at (*atd created_at *): date_time;
  branch_updated_at (*atd updated_at *): date_time;
  branch_code_owner_approval_required (*atd code_owner_approval_required *):
    bool
}

type external_status_check = {
  external_status_check_id (*atd id *): int;
  external_status_check_name (*atd name *): string;
  external_status_check_project_id (*atd project_id *): int;
  external_status_check_external_url (*atd external_url *): string;
  external_status_check_protected_branches (*atd protected_branches *):
    branch list
}

type external_status_checks = external_status_check list

type event_target_type = [
    `Issue | `Milestone | `MergeRequest | `Note | `Project | `Snippet | `User
  | `WikiPage | `DiffNote | `DiscussionNote
]

type event_action_name = [
    `Accepted | `Approved | `Closed | `CommentedOn | `Created | `Destroyed
  | `Deleted | `Expired | `Joined | `Left | `Merged | `Opened | `Pushed
  | `PushedTo | `PushedNew | `Reopened | `Updated
]

type event = {
  event_id (*atd id *): int;
  event_project_id (*atd project_id *): int;
  event_action_name (*atd action_name *): event_action_name option;
  event_target_id (*atd target_id *): int option;
  event_target_iid (*atd target_iid *): int option;
  event_target_type (*atd target_type *): event_target_type option;
  event_author_id (*atd author_id *): int;
  event_target_title (*atd target_title *): string option;
  event_created_at (*atd created_at *): date_time;
  event_author (*atd author *): user_short option;
  event_push_data (*atd push_data *): push_data option;
  event_note (*atd note *): note option;
  event_wiki_page (*atd wiki_page *): wiki_page option;
  event_author_username (*atd author_username *): string
}

type events = event list

type event_action_type = [
    `Approved | `Closed | `Commented | `Created | `Destroyed | `Expired
  | `Joined | `Left | `Merged | `Pushed | `Reopened | `Updated
]

type error_detail = { message: string; detail: string option }

type current_user = {
  current_user_id (*atd id *): int;
  current_user_name (*atd name *): string;
  current_user_username (*atd username *): string;
  current_user_state (*atd state *): string option;
  current_user_avatar_url (*atd avatar_url *): string option;
  current_user_web_url (*atd web_url *): string option;
  current_user_email (*atd email *): string option;
  current_user_created_at (*atd created_at *): date_time;
  current_user_bio (*atd bio *): string option;
  current_user_bio_html (*atd bio_html *): string option;
  current_user_location (*atd location *): string option;
  current_user_public_email (*atd public_email *): string option;
  current_user_skype (*atd skype *): string option;
  current_user_linkedin (*atd linkedin *): string option;
  current_user_twitter (*atd twitter *): string option;
  current_user_discord (*atd discord *): string option;
  current_user_website_url (*atd website_url *): string option;
  current_user_organization (*atd organization *): string option;
  current_user_job_title (*atd job_title *): string option;
  current_user_pronouns (*atd pronouns *): string option;
  current_user_bot (*atd bot *): bool;
  current_user_work_information (*atd work_information *): string option;
  current_user_followers (*atd followers *): int option;
  current_user_following (*atd following *): int option;
  current_user_local_time (*atd local_time *): string;
  current_user_last_sign_in_at (*atd last_sign_in_at *): date_time;
  current_user_confirmed_at (*atd confirmed_at *): date_time;
  current_user_last_activity_on (*atd last_activity_on *): date;
  current_user_theme_id (*atd theme_id *): int;
  current_user_color_scheme_id (*atd color_scheme_id *): int;
  current_user_projects_limit (*atd projects_limit *): int;
  current_user_current_sign_in_at (*atd current_sign_in_at *): date_time;
  current_user_identities (*atd identities *): identity list;
  current_user_can_create_group (*atd can_create_group *): bool;
  current_user_can_create_project (*atd can_create_project *): bool;
  current_user_two_factor_enabled (*atd two_factor_enabled *): bool;
  current_user_external (*atd external *): bool;
  current_user_private_profile (*atd private_profile *): bool;
  current_user_commit_email (*atd commit_email *): string;
  current_user_shared_runners_minutes_limit (*atd shared_runners_minutes_limit *):
    int;
  current_user_extra_shared_runners_minutes_limit (*atd extra_shared_runners_minutes_limit *):
    string option;
  current_user_scim_identities (*atd scim_identities *): scim_identity list
}

type create_project_hook = {
  id: int option;
  url: string;
  confidential_issues_events: bool option;
  confidential_note_events: bool option;
  deployment_events: bool option;
  enable_ssl_verification: bool option;
  issues_events: bool option;
  job_events: bool option;
  merge_requests_events: bool option;
  note_events: bool option;
  pipeline_events: bool option;
  push_events_branch_filter: string option;
  push_events: bool option;
  releases_events: bool option;
  tag_push_events: bool option;
  repository_update_events: bool option;
  wiki_page_events: bool option;
  token: string option
}

type create_note = {
  create_note_body (*atd body *): string;
  create_note_created_at (*atd created_at *): date_time option;
  create_note_merge_request_diff_sha (*atd merge_request_diff_sha *):
    string option
}

type create_issue = {
  create_issue_assignee_id (*atd assignee_id *): int option;
  create_issue_assignee_ids (*atd assignee_ids *): int option;
  create_issue_confidential (*atd confidential *): bool option;
  create_issue_created_at (*atd created_at *): date_time option;
  create_issue_description (*atd description *): string option;
  create_issue_discussion_to_resolve (*atd discussion_to_resolve *):
    string option;
  create_issue_due_date (*atd due_date *): date option;
  create_issue_epic_id (*atd epic_id *): int option;
  create_issue_epic_iid (*atd epic_iid *): int option;
  create_issue_id (*atd id *): int;
  create_issue_iid (*atd iid *): int option;
  create_issue_issue_type (*atd issue_type *): issue_type option;
  create_issue_labels (*atd labels *): string list option;
  create_issue_merge_request_to_resolve_discussions_of (*atd merge_request_to_resolve_discussions_of *):
    int option;
  create_issue_milestone_id (*atd milestone_id *): int option;
  create_issue_title (*atd title *): string;
  create_issue_weight (*atd weight *): int option
}

type commits = commit list

type commit_status = {
  commit_status_id (*atd id *): int;
  commit_status_sha (*atd sha *): string;
  commit_status_ref (*atd ref *): string;
  commit_status_status (*atd status *): string;
  commit_status_name (*atd name *): string;
  commit_status_target_url (*atd target_url *): string option;
  commit_status_description (*atd description *): string option;
  commit_status_created_at (*atd created_at *): date_time;
  commit_status_started_at (*atd started_at *): date_time option;
  commit_status_finished_at (*atd finished_at *): date_time option;
  commit_status_allow_failure (*atd allow_failure *): bool;
  commit_status_coverage (*atd coverage *): string option;
  commit_status_author (*atd author *): user_short
}

type commit_statuses = commit_status list

type commit_comment = {
  commit_comment_note (*atd note *): string;
  commit_comment_author (*atd author *): user_short
}

type commit_comments = commit_comment list

type commit_commented = {
  commit_commented_author (*atd author *): user_short;
  commit_commented_created_at (*atd created_at *): date_time;
  commit_commented_line_type (*atd line_type *): line_type;
  commit_commented_path (*atd path *): string;
  commit_commented_line (*atd line *): int;
  commit_commented_note (*atd note *): string
}

type change = {
  change_old_path (*atd old_path *): string;
  change_new_path (*atd new_path *): string;
  change_a_mode (*atd a_mode *): string;
  change_b_mode (*atd b_mode *): string;
  change_diff (*atd diff *): string;
  change_new_file (*atd new_file *): bool;
  change_renamed_file (*atd renamed_file *): bool;
  change_deleted_file (*atd deleted_file *): bool
}

type changes = {
  changes_id (*atd id *): int;
  changes_iid (*atd iid *): int;
  changes_project_id (*atd project_id *): int;
  changes_title (*atd title *): string;
  changes_state (*atd state *): string;
  changes_created_at (*atd created_at *): date_time;
  changes_updated_at (*atd updated_at *): date_time;
  changes_target_branch (*atd target_branch *): string;
  changes_source_branch (*atd source_branch *): string;
  changes_upvotes (*atd upvotes *): int;
  changes_downvotes (*atd downvotes *): int;
  changes_author (*atd author *): user_short;
  changes_assignee (*atd assignee *): user_short option;
  changes_assignees (*atd assignees *): user_short list option;
  changes_reviewers (*atd reviewers *): user_short list;
  changes_source_project_id (*atd source_project_id *): int;
  changes_target_project_id (*atd target_project_id *): int;
  changes_labels (*atd labels *): string list;
  changes_description (*atd description *): string;
  changes_draft (*atd draft *): bool;
  changes_work_in_progress (*atd work_in_progress *): bool;
  changes_milestone (*atd milestone *): milestone option;
  changes_merge_when_pipeline_succeeds (*atd merge_when_pipeline_succeeds *):
    bool;
  changes_merge_status (*atd merge_status *): merge_status;
  changes_subscribed (*atd subscribed *): bool;
  changes_sha (*atd sha *): string;
  changes_merge_commit_sha (*atd merge_commit_sha *): string option;
  changes_squash_commit_sha (*atd squash_commit_sha *): string option;
  changes_user_notes_count (*atd user_notes_count *): int;
  changes_changes_count (*atd changes_count *): int;
  changes_should_remove_source_branch (*atd should_remove_source_branch *):
    bool;
  changes_force_remove_source_branch (*atd force_remove_source_branch *):
    bool;
  changes_squash (*atd squash *): bool;
  changes_web_url (*atd web_url *): string;
  changes_references (*atd references *): references;
  changes_discussion_locked (*atd discussion_locked *): bool;
  changes_time_stats (*atd time_stats *): time_stats;
  changes_task_completion_status (*atd task_completion_status *):
    task_completion_status;
  changes_changes (*atd changes *): change list;
  changes_overflow (*atd overflow *): bool
}

type branch_full = {
  branch_full_name (*atd name *): string;
  branch_full_merged (*atd merged *): bool;
  branch_full_protected (*atd protected *): bool;
  branch_full_developers_can_push (*atd developers_can_push *): bool;
  branch_full_developers_can_merge (*atd developers_can_merge *): bool;
  branch_full_can_push (*atd can_push *): bool;
  branch_full_default (*atd default *): bool;
  branch_full_web_url (*atd web_url *): string;
  branch_full_commit (*atd commit *): commit
}

type branches_full = branch_full list

type auth = {
  access_token: string;
  token_type: string;
  expires_in: int;
  refresh_token: string;
  created_at: int
}
